Index: /trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 649)
+++ /trunk/src/VBox/Frontends/VirtualBox/VBoxUI.pro	(revision 650)
@@ -125,6 +125,8 @@
 	images/adjust_win_size_16px.png \
 	images/adjust_win_size_disabled_16px.png \
-	images/auto_resize_16px.png \
-	images/auto_resize_disabled_16px.png \
+	images/auto_resize_on_16px.png \
+	images/auto_resize_on_disabled_16px.png \
+	images/auto_resize_off_16px.png \
+	images/auto_resize_off_disabled_16px.png \
 	images/exit_16px.png \
 	images/fd_unmount_16px.png \
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleWnd.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleWnd.h	(revision 649)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleWnd.h	(revision 650)
@@ -215,4 +215,5 @@
     QIStateIndicator *hd_light, *cd_light, *fd_light, *net_light, *usb_light;
     QIStateIndicator *mouse_state, *hostkey_state;
+    QIStateIndicator *autoresize_state;
     QHBox *hostkey_hbox;
     QLabel *hostkey_name;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 649)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 650)
@@ -184,5 +184,5 @@
     vmAutoresizeGuestAction = new QAction (runningActions, "vmAutoresizeGuestAction");
     vmAutoresizeGuestAction->setIconSet (
-        VBoxGlobal::iconSet ("auto_resize_16px.png", "auto_resize_disabled_16px.png"));
+        VBoxGlobal::iconSet ("auto_resize_on_16px.png", "auto_resize_on_disabled_16px.png"));
     vmAutoresizeGuestAction->setToggleAction (true);
 
@@ -372,6 +372,12 @@
     usb_light->setStateIcon (CEnums::DeviceWriting, QPixmap::fromMimeSource ("usb_write_16px.png"));
     usb_light->setStateIcon (CEnums::InvalidActivity, QPixmap::fromMimeSource ("usb_disabled_16px.png"));
+    /* auto resize state */
+    (new QFrame (indicatorBox))->setFrameStyle (QFrame::VLine | QFrame::Sunken);
+    autoresize_state = new QIStateIndicator (1, indicatorBox, "autoresize_state", WNoAutoErase);
+    autoresize_state->setStateIcon (0, QPixmap::fromMimeSource ("auto_resize_off_disabled_16px.png"));
+    autoresize_state->setStateIcon (1, QPixmap::fromMimeSource ("auto_resize_off_16px.png"));
+    autoresize_state->setStateIcon (2, QPixmap::fromMimeSource ("auto_resize_on_disabled_16px.png"));
+    autoresize_state->setStateIcon (3, QPixmap::fromMimeSource ("auto_resize_on_16px.png"));
     /* mouse */
-    (new QFrame (indicatorBox))->setFrameStyle (QFrame::VLine | QFrame::Sunken);
     mouse_state = new QIStateIndicator (0, indicatorBox, "mouse_state", WNoAutoErase);
     mouse_state->setStateIcon (0, QPixmap::fromMimeSource ("mouse_disabled_16px.png"));
@@ -381,5 +387,4 @@
     mouse_state->setStateIcon (4, QPixmap::fromMimeSource ("mouse_seamless_disabled_16px.png"));
     /* host key */
-    (new QFrame (indicatorBox))->setFrameStyle (QFrame::VLine | QFrame::Sunken);
     hostkey_hbox = new QHBox (indicatorBox, "hostkey_hbox");
     hostkey_hbox->setSpacing (3);
@@ -389,7 +394,6 @@
     hostkey_state->setStateIcon (2, QPixmap::fromMimeSource ("hostkey_pressed_16px.png"));
     hostkey_state->setStateIcon (3, QPixmap::fromMimeSource ("hostkey_captured_pressed_16px.png"));
-    hostkey_name = new QLabel (
-        QIHotKeyEdit::keyName (vboxGlobal().settings().hostKey()), hostkey_hbox, "hostkey_name"
-    );
+    hostkey_name = new QLabel (QIHotKeyEdit::keyName (vboxGlobal().settings().hostKey()),
+                               hostkey_hbox, "hostkey_name");
     /* add to statusbar */
     statusBar()->addWidget (indicatorBox, 0, true);
@@ -1150,8 +1154,17 @@
     /* status bar widgets */
 
+    QToolTip::add (autoresize_state,
+        tr ("Indicates whether the guest display auto-resize function is On "
+            "(<img src=auto_resize_on_16px.png/>) or Off (<img src=auto_resize_off_16px.png/>)"));
     QToolTip::add (mouse_state,
-        tr ("Indicates whether the host mouse pointer is captured by the guest OS"));
+        tr ("Indicates whether the host mouse pointer is captured by the guest OS:<br>"
+            "<nobr><img src=mouse_disabled_16px.png/>&nbsp;&nbsp;poinyrt is not captured</nobr><br>"
+            "<nobr><img src=mouse_16px.png/>&nbsp;&nbsp;pointer is captured</nobr><br>"
+            "<nobr><img src=mouse_seamless_16px.png/>&nbsp;&nbsp;mouse integration (MI) is On</nobr><br>"
+            "<nobr><img src=mouse_can_seamless_16px.png/>&nbsp;&nbsp;MI is Off, pointer is captured</nobr><br>"
+            "<nobr><img src=mouse_seamless_disabled_16px.png/>&nbsp;&nbsp;MI is Off, pointer is not captured</nobr>"));
     QToolTip::add (hostkey_state,
-        tr ("Indicates whether the keyboard is captured by the guest OS"));
+        tr ("Indicates whether the keyboard is captured by the guest OS "
+            "(<img src=hostkey_captured_16px.png/>) or not (<img src=hostkey_16px.png/>)"));
     QToolTip::add (hostkey_name,
         tr ("Shows the currently assigned host key"));
@@ -1453,6 +1466,13 @@
 void VBoxConsoleWnd::vmAutoresizeGuest (bool on)
 {
-    if (console)
-        console->setAutoresizeGuest (on);
+    if (!console)
+        return;
+
+    /* Currently, we use only "off" and "on" icons. Later,
+     * we may want to use disabled versions of icons when no guest additions
+     * are available (to indicate that this function is ineffective). */
+    autoresize_state->setState (on ? 3 : 1);
+
+    console->setAutoresizeGuest (on);
 }
 