Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 1214)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 1215)
@@ -224,4 +224,5 @@
     QToolButton *mBtnEdit;
     QTextBrowser *mBrowser;
+    QBrush mBrowserPaper;
 };
 
@@ -232,21 +233,23 @@
 {
     /* main layout creation */
-    QVBoxLayout *mainLayout = new QVBoxLayout (this, 10, 10, "mainLayout");
+    QVBoxLayout *mainLayout = new QVBoxLayout (this, 0, 10, "mainLayout");
+
     /* mBrowser creation */
     mBrowser = new QTextBrowser (this, "mBrowser");
+    mBrowserPaper = mBrowser->paper();
     mBrowser->setSizePolicy (QSizePolicy::Expanding, QSizePolicy::Expanding);
     mBrowser->setFocusPolicy (QWidget::StrongFocus);
     mBrowser->setLinkUnderline (false);
-    mBrowser->setFrameShape (QFrame::NoFrame);
-    mBrowser->setPaper (backgroundBrush());
     mainLayout->addWidget (mBrowser);
+
     /* button layout creation */
     QHBoxLayout *btnLayout = new QHBoxLayout (mainLayout, 10, "btnLayout");
-    QSpacerItem *spacer = new QSpacerItem (0, 0,
-                                           QSizePolicy::Expanding,
-                                           QSizePolicy::Minimum);
-    btnLayout->addItem (spacer);
+    btnLayout->addItem (new QSpacerItem (0, 0,
+                                         QSizePolicy::Expanding,
+                                         QSizePolicy::Minimum));
+
     /* button creation */
     mBtnEdit = new QToolButton (this, "mBtnEdit");
+    mBtnEdit->setSizePolicy (QSizePolicy::Preferred, QSizePolicy::Fixed);
     mBtnEdit->setFocusPolicy (QWidget::StrongFocus);
     mBtnEdit->setIconSet (VBoxGlobal::iconSet ("edit_shared_folder_16px.png",
@@ -257,4 +260,8 @@
     btnLayout->addWidget (mBtnEdit);
 
+    mainLayout->addItem (new QSpacerItem (0, 0,
+                                          QSizePolicy::Expanding,
+                                          QSizePolicy::Minimum));
+
     /* apply language settings */
     languageChange();
@@ -263,5 +270,20 @@
 void VBoxVMDescriptionPage::setMachine (const CMachine &aMachine)
 {
-    mBrowser->setText (aMachine.GetDescription());
+    QString text = aMachine.GetDescription();
+    if (text.isEmpty())
+        text = QString::null;
+
+    if (!text.isNull())
+    {
+        mBrowser->setText (text);
+        mBrowser->setPaper (mBrowserPaper);
+        mBrowser->setEnabled (true);
+    }
+    else
+    {
+        mBrowser->setText (tr ("No description. Press the Edit button below to add it."));
+        mBrowser->setEnabled (false);
+        mBrowser->setPaper (backgroundBrush());
+    }
 }
 
@@ -270,4 +292,5 @@
     mBtnEdit->setTextLabel (tr ("Edit"));
     mBtnEdit->setAccel (QString ("Ctrl+E"));
+    QToolTip::add (mBtnEdit, tr ("Edit (Ctrl+E)"));
 }
 
@@ -910,5 +933,5 @@
     vmTabWidget->changeTab (vmDetailsView, tr ("&Details"));
     vmTabWidget->changeTab (vmSnapshotsWgt, tr ("&Snapshots"));
-    vmTabWidget->changeTab (vmDescriptionPage, tr ("Des&cription"));
+    vmTabWidget->changeTab (vmDescriptionPage, tr ("D&escription"));
 
     /* ensure the details and screenshot view are updated */
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 1214)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsDlg.ui	(revision 1215)
@@ -1199,21 +1199,15 @@
                                     <number>10</number>
                                 </property>
-                                <widget class="QGroupBox">
+                                <widget class="QTextEdit">
                                     <property name="name">
-                                        <cstring>gbDescription</cstring>
-                                    </property>
-                                    <property name="title">
-                                        <string>Virtual Machine &amp;Description</string>
-                                    </property>
-                                    <vbox>
-                                        <property name="name">
-                                            <cstring>unnamed</cstring>
-                                        </property>
-                                        <widget class="QTextEdit">
-                                            <property name="name">
-                                                <cstring>teDescription</cstring>
-                                            </property>
-                                        </widget>
-                                    </vbox>
+                                        <cstring>teDescription</cstring>
+                                    </property>
+                                    <property name="whatsThis" stdset="0">
+                                        <string>Displays the description of
+                                        the virtual machine. The description
+                                        field is useful for commenting
+                                        configuration details of the installed
+                                        guest OS.</string>
+                                    </property>
                                 </widget>
                             </vbox>